#!/usr/bin/env python

from moinformat import all_parsers, get_serialiser, parse, serialise
from os.path import split
import sys

def test_option(args, name):
    if name in args:
        args.remove(name)
        return True
    else:
        return False

def main():
    dirname, progname = split(sys.argv[0])
    args = sys.argv[1:]

    l = filenames = []
    formats = []
    tree = False

    for arg in args:

        # Detect tree output.

        if arg == "--tree":
            tree = True

        # Switch to collecting formats

        elif arg == "--format":
            l = formats
            continue

        # Collect options and arguments.

        else:
            l.append(arg)

        # Collect filenames normally.

        l = filenames

    filename = filenames[0]

    f = open(filename)
    try:
        d = parse(f.read(), all_parsers)
        if tree:
            print d.prettyprint()
        else:
            format = formats and formats[0] or "html"
            print serialise(d, get_serialiser(format))
    finally:
        f.close()

if __name__ == "__main__":
    main()

# vim: tabstop=4 expandtab shiftwidth=4
